
#' Model fit to the Berkeley data for males
#'
#' @description Bayesian SITAR model fit to the [bsitar::berkeley_mdata] 
#'   data that contains longitudinal growth measurements for 66 males (6 
#'   to 20 years of age).
#'
#' @details Data details are provided in the [bsitar::berkeley_mdata].
#'
#'
#' @name berkeley_mfit
#' @docType data
#' @format Model fit comprising summary of posterior draws.
#' 
#' @keywords datasets
#' 
#' @return An object of class \code{bgmfit} with posterior draws.
#' 
#' @inherit berkeley author
"berkeley_mfit"